/** @file pourRNA_cmdl.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.6
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef POURRNA_CMDL_H
#define POURRNA_CMDL_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef POURRNA_CMDLINE_PARSER_PACKAGE
/** @brief the program name (used for printing errors) */
#define POURRNA_CMDLINE_PARSER_PACKAGE "pourRNA"
#endif

#ifndef POURRNA_CMDLINE_PARSER_PACKAGE_NAME
/** @brief the complete program name (used for help and version) */
#define POURRNA_CMDLINE_PARSER_PACKAGE_NAME "pourRNA"
#endif

#ifndef POURRNA_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define POURRNA_CMDLINE_PARSER_VERSION VERSION
#endif

/** @brief Where the command line options are stored */
struct pourRNA_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  char * sequence_arg;	/**< @brief The RNA sequence of the molecule
 (default='ACUGUAUGCGCGU').  */
  char * sequence_orig;	/**< @brief The RNA sequence of the molecule
 original value given at command line.  */
  const char *sequence_help; /**< @brief The RNA sequence of the molecule
 help description.  */
  char * start_structure_arg;	/**< @brief the start structure of the exploration defining the first gradient basin; defaults to the open chain
.  */
  char * start_structure_orig;	/**< @brief the start structure of the exploration defining the first gradient basin; defaults to the open chain
 original value given at command line.  */
  const char *start_structure_help; /**< @brief the start structure of the exploration defining the first gradient basin; defaults to the open chain
 help description.  */
  char * start_structure_file_arg;	/**< @brief File with start structures (one per line)
.  */
  char * start_structure_file_orig;	/**< @brief File with start structures (one per line)
 original value given at command line.  */
  const char *start_structure_file_help; /**< @brief File with start structures (one per line)
 help description.  */
  char * final_structure_arg;	/**< @brief the final structure of the exploration defining the last gradient basin
.  */
  char * final_structure_orig;	/**< @brief the final structure of the exploration defining the last gradient basin
 original value given at command line.  */
  const char *final_structure_help; /**< @brief the final structure of the exploration defining the last gradient basin
 help description.  */
  int max_threads_arg;	/**< @brief Sets the maximum number of threads for parallelized computation.
.  */
  char * max_threads_orig;	/**< @brief Sets the maximum number of threads for parallelized computation.
 original value given at command line.  */
  const char *max_threads_help; /**< @brief Sets the maximum number of threads for parallelized computation.
 help description.  */
  int filter_best_k_arg;	/**< @brief reduces outgoing transitions to the best K for each gradient basin
.  */
  char * filter_best_k_orig;	/**< @brief reduces outgoing transitions to the best K for each gradient basin
 original value given at command line.  */
  const char *filter_best_k_help; /**< @brief reduces outgoing transitions to the best K for each gradient basin
 help description.  */
  int dynamic_best_k_flag;	/**< @brief Increases K if the MFE structure is not explored.
 (default=off).  */
  const char *dynamic_best_k_help; /**< @brief Increases K if the MFE structure is not explored.
 help description.  */
  double max_neigh_e_arg;	/**< @brief reduces outgoing transitions to the neighbored minima, for which the energy is lower than the energy of the current minimum plus the filter value. (E(neighbored minimum) < E(current minimum) + filterValue) for each gradient basin.
.  */
  char * max_neigh_e_orig;	/**< @brief reduces outgoing transitions to the neighbored minima, for which the energy is lower than the energy of the current minimum plus the filter value. (E(neighbored minimum) < E(current minimum) + filterValue) for each gradient basin.
 original value given at command line.  */
  const char *max_neigh_e_help; /**< @brief reduces outgoing transitions to the neighbored minima, for which the energy is lower than the energy of the current minimum plus the filter value. (E(neighbored minimum) < E(current minimum) + filterValue) for each gradient basin.
 help description.  */
  int max_to_queue_arg;	/**< @brief Sets the maximum number of states to be stored in the priority queue of the flooder.
.  */
  char * max_to_queue_orig;	/**< @brief Sets the maximum number of states to be stored in the priority queue of the flooder.
 original value given at command line.  */
  const char *max_to_queue_help; /**< @brief Sets the maximum number of states to be stored in the priority queue of the flooder.
 help description.  */
  int max_to_hash_arg;	/**< @brief Sets the maximum number of states to be hashed for a gradient walk.
.  */
  char * max_to_hash_orig;	/**< @brief Sets the maximum number of states to be hashed for a gradient walk.
 original value given at command line.  */
  const char *max_to_hash_help; /**< @brief Sets the maximum number of states to be hashed for a gradient walk.
 help description.  */
  int dynamic_max_to_hash_flag;	/**< @brief Sets the dynamicMaxToHash variable for estimating the maximal number of states to be hashed in a gradient walk, by considering the maximal available physical memory and the number of threads. This reduces the probability of swapping.
 (default=off).  */
  const char *dynamic_max_to_hash_help; /**< @brief Sets the dynamicMaxToHash variable for estimating the maximal number of states to be hashed in a gradient walk, by considering the maximal available physical memory and the number of threads. This reduces the probability of swapping.
 help description.  */
  double max_energy_arg;	/**< @brief Sets the maximum energy that a state is allowed to have to be considered by the flooder (in kcal/mol).
 (default='5').  */
  char * max_energy_orig;	/**< @brief Sets the maximum energy that a state is allowed to have to be considered by the flooder (in kcal/mol).
 original value given at command line.  */
  const char *max_energy_help; /**< @brief Sets the maximum energy that a state is allowed to have to be considered by the flooder (in kcal/mol).
 help description.  */
  double delta_e_arg;	/**< @brief Set the maximum energy difference that states in a basin can have w.r.t. the local minimum (in kcal/mol).
 (default='65536').  */
  char * delta_e_orig;	/**< @brief Set the maximum energy difference that states in a basin can have w.r.t. the local minimum (in kcal/mol).
 original value given at command line.  */
  const char *delta_e_help; /**< @brief Set the maximum energy difference that states in a basin can have w.r.t. the local minimum (in kcal/mol).
 help description.  */
  int max_bp_dist_add_arg;	/**< @brief Increases the maximum base pair distance for direct neighbor minima to be explored. Needs a start structure and a final structure in order to work. For all discovered minima m holds: bp_dist(m, start-structure) + bp_dist(m, final-structure) < d(start-structure, final-structure) + maxBPdist_add.
  If this parameter is given, the explorative flooding will not stop at the final structure! Instead
  it will explore all minima on the direct path and at its borders. This helps to evaluate optimal refolding paths
  in a post-processing step.
 (default='65536').  */
  char * max_bp_dist_add_orig;	/**< @brief Increases the maximum base pair distance for direct neighbor minima to be explored. Needs a start structure and a final structure in order to work. For all discovered minima m holds: bp_dist(m, start-structure) + bp_dist(m, final-structure) < d(start-structure, final-structure) + maxBPdist_add.
  If this parameter is given, the explorative flooding will not stop at the final structure! Instead
  it will explore all minima on the direct path and at its borders. This helps to evaluate optimal refolding paths
  in a post-processing step.
 original value given at command line.  */
  const char *max_bp_dist_add_help; /**< @brief Increases the maximum base pair distance for direct neighbor minima to be explored. Needs a start structure and a final structure in order to work. For all discovered minima m holds: bp_dist(m, start-structure) + bp_dist(m, final-structure) < d(start-structure, final-structure) + maxBPdist_add.
  If this parameter is given, the explorative flooding will not stop at the final structure! Instead
  it will explore all minima on the direct path and at its borders. This helps to evaluate optimal refolding paths
  in a post-processing step.
 help description.  */
  double temperature_arg;	/**< @brief Set the temperature for the free energy calculation (in °C). (If \"T\" is set and \"B\" not, \"B\" is equals \"T\").
 (default='37').  */
  char * temperature_orig;	/**< @brief Set the temperature for the free energy calculation (in °C). (If \"T\" is set and \"B\" not, \"B\" is equals \"T\").
 original value given at command line.  */
  const char *temperature_help; /**< @brief Set the temperature for the free energy calculation (in °C). (If \"T\" is set and \"B\" not, \"B\" is equals \"T\").
 help description.  */
  int dangling_end_arg;	/**< @brief How to treat \"dangling end\" energies for bases adjacent to helices in free ends and multi-loops.
 (default='2').  */
  char * dangling_end_orig;	/**< @brief How to treat \"dangling end\" energies for bases adjacent to helices in free ends and multi-loops.
 original value given at command line.  */
  const char *dangling_end_help; /**< @brief How to treat \"dangling end\" energies for bases adjacent to helices in free ends and multi-loops.
 help description.  */
  double boltzmann_temp_arg;	/**< @brief Set the temperature for the Boltzmann weight (in °C).
 (default='37').  */
  char * boltzmann_temp_orig;	/**< @brief Set the temperature for the Boltzmann weight (in °C).
 original value given at command line.  */
  const char *boltzmann_temp_help; /**< @brief Set the temperature for the Boltzmann weight (in °C).
 help description.  */
  int energy_model_arg;	/**< @brief Set the energy model. 0=Turner model 2004, 1=Turner model 1999, 2=Andronescu model, 2007
 (default='0').  */
  char * energy_model_orig;	/**< @brief Set the energy model. 0=Turner model 2004, 1=Turner model 1999, 2=Andronescu model, 2007
 original value given at command line.  */
  const char *energy_model_help; /**< @brief Set the energy model. 0=Turner model 2004, 1=Turner model 1999, 2=Andronescu model, 2007
 help description.  */
  int move_set_arg;	/**< @brief Move set: 0 = insertion and deletion, 1 = shift moves, 2 = no lonely pair moves.
 (default='0').  */
  char * move_set_orig;	/**< @brief Move set: 0 = insertion and deletion, 1 = shift moves, 2 = no lonely pair moves.
 original value given at command line.  */
  const char *move_set_help; /**< @brief Move set: 0 = insertion and deletion, 1 = shift moves, 2 = no lonely pair moves.
 help description.  */
  char * transition_prob_arg;	/**< @brief If provided, the transition probability matrix will be written to the given file name or 'STDOUT' when to write to standard output
.  */
  char * transition_prob_orig;	/**< @brief If provided, the transition probability matrix will be written to the given file name or 'STDOUT' when to write to standard output
 original value given at command line.  */
  const char *transition_prob_help; /**< @brief If provided, the transition probability matrix will be written to the given file name or 'STDOUT' when to write to standard output
 help description.  */
  char * energy_file_arg;	/**< @brief File to store all energies.
.  */
  char * energy_file_orig;	/**< @brief File to store all energies.
 original value given at command line.  */
  const char *energy_file_help; /**< @brief File to store all energies.
 help description.  */
  char * binary_rates_file_arg;	/**< @brief File to store all rates in a treekin readable format.
.  */
  char * binary_rates_file_orig;	/**< @brief File to store all rates in a treekin readable format.
 original value given at command line.  */
  const char *binary_rates_file_help; /**< @brief File to store all rates in a treekin readable format.
 help description.  */
  char * binary_rates_file_sparse_arg;	/**< @brief File to store all rates in a sparse binary format: First value is the number of states (uint_32), then <uint_32 from>, <uint_32 number of how many value pairs to>, <value pair <uint_32 to, double rate from, to>> etc.
.  */
  char * binary_rates_file_sparse_orig;	/**< @brief File to store all rates in a sparse binary format: First value is the number of states (uint_32), then <uint_32 from>, <uint_32 number of how many value pairs to>, <value pair <uint_32 to, double rate from, to>> etc.
 original value given at command line.  */
  const char *binary_rates_file_sparse_help; /**< @brief File to store all rates in a sparse binary format: First value is the number of states (uint_32), then <uint_32 from>, <uint_32 number of how many value pairs to>, <value pair <uint_32 to, double rate from, to>> etc.
 help description.  */
  char * saddle_file_arg;	/**< @brief Store all saddles in a CSV file..  */
  char * saddle_file_orig;	/**< @brief Store all saddles in a CSV file. original value given at command line.  */
  const char *saddle_file_help; /**< @brief Store all saddles in a CSV file. help description.  */
  char * barriers_like_output_arg;	/**< @brief Output the rates file and the structures in a format similar to the tool barriers. For the same prefix is used for both files..  */
  char * barriers_like_output_orig;	/**< @brief Output the rates file and the structures in a format similar to the tool barriers. For the same prefix is used for both files. original value given at command line.  */
  const char *barriers_like_output_help; /**< @brief Output the rates file and the structures in a format similar to the tool barriers. For the same prefix is used for both files. help description.  */
  char * partition_functions_arg;	/**< @brief If provided, the partition function matrix will be written to the given file name.
.  */
  char * partition_functions_orig;	/**< @brief If provided, the partition function matrix will be written to the given file name.
 original value given at command line.  */
  const char *partition_functions_help; /**< @brief If provided, the partition function matrix will be written to the given file name.
 help description.  */
  char * dot_plot_arg;	/**< @brief If provided, the dotPlot will be written to the given file name. The dotPlot contains the base pair probabilities for all structures in the (filtered) energy landscape.
.  */
  char * dot_plot_orig;	/**< @brief If provided, the dotPlot will be written to the given file name. The dotPlot contains the base pair probabilities for all structures in the (filtered) energy landscape.
 original value given at command line.  */
  const char *dot_plot_help; /**< @brief If provided, the dotPlot will be written to the given file name. The dotPlot contains the base pair probabilities for all structures in the (filtered) energy landscape.
 help description.  */
  char * dot_plot_per_basin_arg;	/**< @brief Creates a dotplot for each gradient basin in the enrgy landscape. It shows the Maximum Expected Accuracy (MEA) structure in the upper right triangle and the basin representative in the lower left triangle.
.  */
  char * dot_plot_per_basin_orig;	/**< @brief Creates a dotplot for each gradient basin in the enrgy landscape. It shows the Maximum Expected Accuracy (MEA) structure in the upper right triangle and the basin representative in the lower left triangle.
 original value given at command line.  */
  const char *dot_plot_per_basin_help; /**< @brief Creates a dotplot for each gradient basin in the enrgy landscape. It shows the Maximum Expected Accuracy (MEA) structure in the upper right triangle and the basin representative in the lower left triangle.
 help description.  */
  int verbose_flag;	/**< @brief Verbose.
 (default=off).  */
  const char *verbose_help; /**< @brief Verbose.
 help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int sequence_given ;	/**< @brief Whether sequence was given.  */
  unsigned int start_structure_given ;	/**< @brief Whether start-structure was given.  */
  unsigned int start_structure_file_given ;	/**< @brief Whether start-structure-file was given.  */
  unsigned int final_structure_given ;	/**< @brief Whether final-structure was given.  */
  unsigned int max_threads_given ;	/**< @brief Whether max-threads was given.  */
  unsigned int filter_best_k_given ;	/**< @brief Whether filter-best-k was given.  */
  unsigned int dynamic_best_k_given ;	/**< @brief Whether dynamic-best-k was given.  */
  unsigned int max_neigh_e_given ;	/**< @brief Whether max-neigh-e was given.  */
  unsigned int max_to_queue_given ;	/**< @brief Whether max-to-queue was given.  */
  unsigned int max_to_hash_given ;	/**< @brief Whether max-to-hash was given.  */
  unsigned int dynamic_max_to_hash_given ;	/**< @brief Whether dynamic-max-to-hash was given.  */
  unsigned int max_energy_given ;	/**< @brief Whether max-energy was given.  */
  unsigned int delta_e_given ;	/**< @brief Whether delta-e was given.  */
  unsigned int max_bp_dist_add_given ;	/**< @brief Whether max-bp-dist-add was given.  */
  unsigned int temperature_given ;	/**< @brief Whether temperature was given.  */
  unsigned int dangling_end_given ;	/**< @brief Whether dangling-end was given.  */
  unsigned int boltzmann_temp_given ;	/**< @brief Whether boltzmann-temp was given.  */
  unsigned int energy_model_given ;	/**< @brief Whether energy-model was given.  */
  unsigned int move_set_given ;	/**< @brief Whether move-set was given.  */
  unsigned int transition_prob_given ;	/**< @brief Whether transition-prob was given.  */
  unsigned int energy_file_given ;	/**< @brief Whether energy-file was given.  */
  unsigned int binary_rates_file_given ;	/**< @brief Whether binary-rates-file was given.  */
  unsigned int binary_rates_file_sparse_given ;	/**< @brief Whether binary-rates-file-sparse was given.  */
  unsigned int saddle_file_given ;	/**< @brief Whether saddle-file was given.  */
  unsigned int barriers_like_output_given ;	/**< @brief Whether barriers-like-output was given.  */
  unsigned int partition_functions_given ;	/**< @brief Whether partition-functions was given.  */
  unsigned int dot_plot_given ;	/**< @brief Whether dot-plot was given.  */
  unsigned int dot_plot_per_basin_given ;	/**< @brief Whether dot-plot-per-basin was given.  */
  unsigned int verbose_given ;	/**< @brief Whether verbose was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct pourRNA_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure pourRNA_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure pourRNA_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *pourRNA_args_info_purpose;
/** @brief the usage string of the program */
extern const char *pourRNA_args_info_usage;
/** @brief the description string of the program */
extern const char *pourRNA_args_info_description;
/** @brief all the lines making the help output */
extern const char *pourRNA_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int pourRNA_cmdline_parser (int argc, char **argv,
  struct pourRNA_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use pourRNA_cmdline_parser_ext() instead
 */
int pourRNA_cmdline_parser2 (int argc, char **argv,
  struct pourRNA_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int pourRNA_cmdline_parser_ext (int argc, char **argv,
  struct pourRNA_args_info *args_info,
  struct pourRNA_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int pourRNA_cmdline_parser_dump(FILE *outfile,
  struct pourRNA_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int pourRNA_cmdline_parser_file_save(const char *filename,
  struct pourRNA_args_info *args_info);

/**
 * Print the help
 */
void pourRNA_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void pourRNA_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a pourRNA_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void pourRNA_cmdline_parser_params_init(struct pourRNA_cmdline_parser_params *params);

/**
 * Allocates dynamically a pourRNA_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized pourRNA_cmdline_parser_params structure
 */
struct pourRNA_cmdline_parser_params *pourRNA_cmdline_parser_params_create(void);

/**
 * Initializes the passed pourRNA_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void pourRNA_cmdline_parser_init (struct pourRNA_args_info *args_info);
/**
 * Deallocates the string fields of the pourRNA_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void pourRNA_cmdline_parser_free (struct pourRNA_args_info *args_info);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int pourRNA_cmdline_parser_required (struct pourRNA_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* POURRNA_CMDL_H */
